VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMapPoint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' (R) 2003 Sergiy Pavlov -- Do not remove this header
'     baal_200@yahoo.com
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  The object that lets you do more with MapPoint ActiveX control.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  This source code is provided "as is" and  can only  be used in accordance
'  with the terms and conditions of the Microsoft MapPoint 2002 and Microsoft
'  Visual Basic End User License Agreements.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

Private Declare Sub Sleep_API Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)

Public WithEvents m_MapPointCtrl As MappointControl
Attribute m_MapPointCtrl.VB_VarHelpID = -1
Public m_Map As MapPointCtl.Map
Private m_AppForm As Form
Private m_ParentWnd As Frame
Private m_hWnd_Frame As Long
Private m_sTmpSaveFilePath As String

Public Property Get Map() As MapPointCtl.Map
     Set Map = m_Map
End Property

Public Property Get hWnd_Frame() As Long
    Dim TWnd As New TWindow
    'm_ParentWnd is a VB frame specifically designated to be the container of MapPoint control
    'This makes life easier
    
    If m_hWnd_Frame = 0 Then
        TWnd.hWnd = m_ParentWnd.hWnd
        TWnd.hWnd = TWnd.FindChildWindow("ATL:", vbNullString, False).hWnd
        If Mid$(TWnd.ClassName, 9, 4) = "2748" Then
            TWnd.hWnd = TWnd.FindChildWindow("ATL:", vbNullString, False).hWnd
            If Mid$(TWnd.ClassName, 9, 4) = "2070" Then
                m_hWnd_Frame = TWnd.FindChildWindow("AfxFrameOrView42", vbNullString).hWnd
            End If
        End If
    End If
    hWnd_Frame = m_hWnd_Frame

End Property

Public Sub SetFocus()
    Dim TWnd As New TWindow
    
    'Set focus to control window
    m_MapPointCtrl.SetFocus
    
End Sub

Public Sub SendCommand(ByVal vData As Long)
    'Sends Or Posts command messages to MapPoint windows
    
    Dim TWnd As New TWindow
    
    TWnd.hWnd = hWnd_Frame

    If vData < 0 Then
        TWnd.PostMessageLong WM_COMMAND, vData
    Else
        TWnd.SendMessageLong WM_COMMAND, vData
    End If
    
End Sub

Public Property Let Left(ByVal vData As Integer)
    m_ParentWnd.Left = vData
End Property

Public Property Get Left() As Integer
    Left = m_ParentWnd.Left
End Property

Public Property Let Top(ByVal vData As Integer)
    m_ParentWnd.Top = vData - 95
End Property

Public Property Get Top() As Integer
    Top = m_MapPointCtrl.Top
End Property

Public Property Let Visible(ByVal vData As Boolean)
    m_MapPointCtrl.Visible = vData
    m_ParentWnd.Visible = vData
End Property

Public Property Get Visible() As Boolean
    Visible = m_ParentWnd.Visible
End Property

Public Property Let width(ByVal vData As Integer)
    m_MapPointCtrl.width = vData
    m_ParentWnd.width = vData
End Property

Public Property Get width() As Integer
    width = m_MapPointCtrl.width
End Property

Public Property Let Height(ByVal vData As Integer)
    m_MapPointCtrl.Height = vData
    m_ParentWnd.Height = vData + 95
End Property

Public Property Get Height() As Integer
    Height = m_MapPointCtrl.Height
End Property

Public Property Let Enabled(ByVal vData As Boolean)
    m_ParentWnd.Enabled = vData
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_ParentWnd.Enabled
End Property
Private Sub Class_Initialize()
    
    Set m_AppForm = fmMain
    Set m_ParentWnd = fmMain.FrameMappointCtrl
    Set m_MapPointCtrl = fmMain.MappointCtrl
    
    m_sTmpSaveFilePath = App.Path & "\" & "temp.ptm"
    
    m_ParentWnd.BorderStyle = vbBSNone
    
    m_MapPointCtrl.Top = 95
    m_MapPointCtrl.Left = 0
    
    Me.Top = 0
    Me.Left = 0
    Me.width = m_ParentWnd.width
    Me.Height = m_ParentWnd.Height - 95
    
    'for MapPoint Europe set EURO to 1 in Project prop. ->Make
    #If EURO = 1 Then
        'Europe:
        Set m_Map = m_MapPointCtrl.NewMap(geoMapEurope)
        m_AppForm.Caption = m_AppForm.Caption & " - Europe"
    #Else
        'NorthAm:
        Set m_Map = m_MapPointCtrl.NewMap(geoMapNorthAmerica)
        m_AppForm.Caption = m_AppForm.Caption & " - North America"
    #End If
    
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    m_MapPointCtrl.SaveMapAs m_sTmpSaveFilePath
    Set m_MapPointCtrl = Nothing
    Set m_Map = Nothing
    Set m_AppForm = Nothing
    Set m_ParentWnd = Nothing
    Kill m_sTmpSaveFilePath
    Err.Clear
End Sub


Private Sub m_MapPointCtrl_ReadyStateChange()
    
    If m_MapPointCtrl.ReadyState = READYSTATE_COMPLETE Then
        'Initialize and remember
        m_hWnd_Frame = hWnd_Frame
    End If
    
End Sub
