Attribute VB_Name = "TWindowSupport"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' (R) 2003 Sergiy Pavlov -- Do not remove this header
' baal_200@yahoo.com
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright (c) 1997-2000 John Robbins -- All rights reserved.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Const KEYEVENTF_EXTENDEDKEY = &H1
Public Const KEYEVENTF_KEYUP = &H2
'
' Virtual Keys, Standard Set
'
Public Const VK_LBUTTON = &H1
Public Const VK_RBUTTON = &H2
Public Const VK_CANCEL = &H3
Public Const VK_MBUTTON = &H4   ' NOT contiguous with L & RBUTTON
Public Const VK_BACK = &H8
Public Const VK_TAB = &H9
Public Const VK_CLEAR = &HC
Public Const VK_RETURN = &HD
Public Const VK_SHIFT = &H10
Public Const VK_CONTROL = &H11
Public Const VK_MENU = &H12
Public Const VK_ALT = &H12
Public Const VK_PAUSE = &H13
Public Const VK_CAPITAL = &H14
Public Const VK_KANA = &H15
Public Const VK_HANGEUL = &H15  ' old name - should be here for compatibility
Public Const VK_HANGUL = &H15
Public Const VK_JUNJA = &H17
Public Const VK_FINAL = &H18
Public Const VK_HANJA = &H19
Public Const VK_KANJI = &H19
Public Const VK_ESCAPE = &H1B
Public Const VK_CONVERT = &H1C
Public Const VK_NONCONVERT = &H1D
Public Const VK_ACCEPT = &H1E
Public Const VK_MODECHANGE = &H1F
Public Const VK_SPACE = &H20
Public Const VK_PRIOR = &H21
Public Const VK_NEXT = &H22
Public Const VK_END = &H23
Public Const VK_HOME = &H24
Public Const VK_LEFT = &H25
Public Const VK_UP = &H26
Public Const VK_RIGHT = &H27
Public Const VK_DOWN = &H28
Public Const VK_SELECT = &H29
Public Const VK_PRINT = &H2A
Public Const VK_EXECUTE = &H2B
Public Const VK_SNAPSHOT = &H2C
Public Const VK_INSERT = &H2D
Public Const VK_DELETE = &H2E
Public Const VK_HELP = &H2F

Public Const VK_0 = &H30
Public Const VK_1 = &H31
Public Const VK_2 = &H32
Public Const VK_3 = &H33
Public Const VK_4 = &H34
Public Const VK_5 = &H35
Public Const VK_6 = &H36
Public Const VK_7 = &H37
Public Const VK_8 = &H38
Public Const VK_9 = &H39

Public Const VK_A = &H41
Public Const VK_B = &H42
Public Const VK_C = &H43
Public Const VK_D = &H44
Public Const VK_E = &H45
Public Const VK_F = &H46
Public Const VK_G = &H47
Public Const VK_H = &H48
Public Const VK_I = &H49
Public Const VK_J = &H4A
Public Const VK_K = &H4B
Public Const VK_L = &H4C
Public Const VK_M = &H4D
Public Const VK_N = &H4E
Public Const VK_O = &H4F
Public Const VK_P = &H50
Public Const VK_Q = &H51
Public Const VK_R = &H52
Public Const VK_S = &H53
Public Const VK_T = &H54
Public Const VK_U = &H55
Public Const VK_V = &H56
Public Const VK_W = &H57
Public Const VK_X = &H58
Public Const VK_Y = &H59
Public Const VK_Z = &H5A

Public Const VK_LWIN = &H5B
Public Const VK_RWIN = &H5C
Public Const VK_APPS = &H5D
Public Const VK_NUMPAD0 = &H60
Public Const VK_NUMPAD1 = &H61
Public Const VK_NUMPAD2 = &H62
Public Const VK_NUMPAD3 = &H63
Public Const VK_NUMPAD4 = &H64
Public Const VK_NUMPAD5 = &H65
Public Const VK_NUMPAD6 = &H66
Public Const VK_NUMPAD7 = &H67
Public Const VK_NUMPAD8 = &H68
Public Const VK_NUMPAD9 = &H69
Public Const VK_MULTIPLY = &H6A
Public Const VK_ADD = &H6B
Public Const VK_SEPARATOR = &H6C
Public Const VK_SUBTRACT = &H6D
Public Const VK_DECIMAL = &H6E
Public Const VK_DIVIDE = &H6F
Public Const VK_F1 = &H70
Public Const VK_F2 = &H71
Public Const VK_F3 = &H72
Public Const VK_F4 = &H73
Public Const VK_F5 = &H74
Public Const VK_F6 = &H75
Public Const VK_F7 = &H76
Public Const VK_F8 = &H77
Public Const VK_F9 = &H78
Public Const VK_F10 = &H79
Public Const VK_F11 = &H7A
Public Const VK_F12 = &H7B
Public Const VK_F13 = &H7C
Public Const VK_F14 = &H7D
Public Const VK_F15 = &H7E
Public Const VK_F16 = &H7F
Public Const VK_F17 = &H80
Public Const VK_F18 = &H81
Public Const VK_F19 = &H82
Public Const VK_F20 = &H83
Public Const VK_F21 = &H84
Public Const VK_F22 = &H85
Public Const VK_F23 = &H86
Public Const VK_F24 = &H87
Public Const VK_NUMLOCK = &H90
Public Const VK_SCROLL = &H91

'
' VK_L* & VK_R* - left and right Alt, Ctrl and Shift virtual keys.
' Used only as parameters to GetAsyncKeyState() and GetKeyState().
' No other API or message will distinguish left and right keys in this way.
'
Public Const VK_LSHIFT = &HA0
Public Const VK_RSHIFT = &HA1
Public Const VK_LCONTROL = &HA2
Public Const VK_RCONTROL = &HA3
Public Const VK_LMENU = &HA4
Public Const VK_RMENU = &HA5
Public Const VK_PROCESSKEY = &HE5
Public Const VK_ATTN = &HF6
Public Const VK_CRSEL = &HF7
Public Const VK_EXSEL = &HF8
Public Const VK_EREOF = &HF9
Public Const VK_PLAY = &HFA
Public Const VK_ZOOM = &HFB
Public Const VK_NONAME = &HFC
Public Const VK_PA1 = &HFD
Public Const VK_OEM_CLEAR = &HFE

'
' WinMessages
'
Public Const WM_NULL = &H0&
Public Const WM_CREATE = &H1&
Public Const WM_DESTROY = &H2&
Public Const WM_MOVE = &H3&
Public Const WM_SIZE = &H5&
Public Const WM_ACTIVATE = &H6&
Public Const WM_SETFOCUS = &H7&
Public Const WM_KILLFOCUS = &H8&
Public Const WM_ENABLE = &HA&
Public Const WM_SETREDRAW = &HB&
Public Const WM_SETTEXT = &HC&
Public Const WM_GETTEXT = &HD&
Public Const WM_GETTEXTLENGTH = &HE&
Public Const WM_PAINT = &HF&
Public Const WM_CLOSE = &H10&
Public Const WM_QUERYENDSESSION = &H11&
Public Const WM_QUIT = &H12&
Public Const WM_QUERYOPEN = &H13&
Public Const WM_ERASEBKGND = &H14&
Public Const WM_SYSCOLORCHANGE = &H15&
Public Const WM_ENDSESSION = &H16&
Public Const WM_SHOWWINDOW = &H18&
Public Const WM_WININICHANGE = &H1A&
Public Const WM_SETTINGCHANGE = &H1A&
Public Const WM_DEVMODECHANGE = &H1B&
Public Const WM_ACTIVATEAPP = &H1C&
Public Const WM_FONTCHANGE = &H1D&
Public Const WM_TIMECHANGE = &H1E&
Public Const WM_CANCELMODE = &H1F&
Public Const WM_SETCURSOR = &H20&
Public Const WM_MOUSEACTIVATE = &H21&
Public Const WM_CHILDACTIVATE = &H22&
Public Const WM_QUEUESYNC = &H23&
Public Const WM_GETMINMAXINFO = &H24&
Public Const WM_PAINTICON = &H26&
Public Const WM_ICONERASEBKGND = &H27&
Public Const WM_NEXTDLGCTL = &H28&
Public Const WM_SPOOLERSTATUS = &H2A&
Public Const WM_DRAWITEM = &H2B&
Public Const WM_MEASUREITEM = &H2C&
Public Const WM_DELETEITEM = &H2D&
Public Const WM_VKEYTOITEM = &H2E&
Public Const WM_CHARTOITEM = &H2F&
Public Const WM_SETFONT = &H30&
Public Const WM_GETFONT = &H31&
Public Const WM_SETHOTKEY = &H32&
Public Const WM_GETHOTKEY = &H33&
Public Const WM_QUERYDRAGICON = &H37&
Public Const WM_COMPAREITEM = &H39&
Public Const WM_GETOBJECT = &H3D&
Public Const WM_COMPACTING = &H41&
Public Const WM_COMMNOTIFY = &H44&
Public Const WM_WINDOWPOSCHANGING = &H46&
Public Const WM_WINDOWPOSCHANGED = &H47&
Public Const WM_POWER = &H48&
Public Const WM_COPYDATA = &H4A&
Public Const WM_CANCELJOURNAL = &H4B&
Public Const WM_NOTIFY = &H4E&
Public Const WM_INPUTLANGCHANGEREQUEST = &H50&
Public Const WM_INPUTLANGCHANGE = &H51&
Public Const WM_TCARD = &H52&
Public Const WM_HELP = &H53&
Public Const WM_USERCHANGED = &H54&
Public Const WM_NOTIFYFORMAT = &H55&
Public Const WM_CONTEXTMENU = &H7B&
Public Const WM_STYLECHANGING = &H7C&
Public Const WM_STYLECHANGED = &H7D&
Public Const WM_DISPLAYCHANGE = &H7E&
Public Const WM_GETICON = &H7F&
Public Const WM_SETICON = &H80&
Public Const WM_NCCREATE = &H81&
Public Const WM_NCDESTROY = &H82&
Public Const WM_NCCALCSIZE = &H83&
Public Const WM_NCHITTEST = &H84&
Public Const WM_NCPAINT = &H85&
Public Const WM_NCACTIVATE = &H86&
Public Const WM_GETDLGCODE = &H87&
Public Const WM_SYNCPAINT = &H88&
Public Const WM_NCMOUSEMOVE = &HA0&
Public Const WM_NCLBUTTONDOWN = &HA1&
Public Const WM_NCLBUTTONUP = &HA2&
Public Const WM_NCLBUTTONDBLCLK = &HA3&
Public Const WM_NCRBUTTONDOWN = &HA4&
Public Const WM_NCRBUTTONUP = &HA5&
Public Const WM_NCRBUTTONDBLCLK = &HA6&
Public Const WM_NCMBUTTONDOWN = &HA7&
Public Const WM_NCMBUTTONUP = &HA8&
Public Const WM_NCMBUTTONDBLCLK = &HA9&
Public Const WM_KEYFIRST = &H100
Public Const WM_KEYDOWN = &H100
Public Const WM_KEYUP = &H101
Public Const WM_CHAR = &H102&
Public Const WM_DEADCHAR = &H103&
Public Const WM_SYSKEYDOWN = &H104&
Public Const WM_SYSKEYUP = &H105&
Public Const WM_SYSCHAR = &H106&
Public Const WM_SYSDEADCHAR = &H107&
Public Const WM_KEYLAST = &H108&
Public Const WM_IME_STARTCOMPOSITION = &H10D&
Public Const WM_IME_ENDCOMPOSITION = &H10E&
Public Const WM_IME_COMPOSITION = &H10F&
Public Const WM_IME_KEYLAST = &H10F&
Public Const WM_INITDIALOG = &H110&
Public Const WM_COMMAND = &H111&
Public Const WM_SYSCOMMAND = &H112&
Public Const WM_TIMER = &H113&
Public Const WM_HSCROLL = &H114&
Public Const WM_VSCROLL = &H115&
Public Const WM_INITMENU = &H116&
Public Const WM_INITMENUPOPUP = &H117&
Public Const WM_MENUSELECT = &H11F&
Public Const WM_MENUCHAR = &H120&
Public Const WM_ENTERIDLE = &H121&
Public Const WM_MENURBUTTONUP = &H122&
Public Const WM_MENUDRAG = &H123&
Public Const WM_MENUGETOBJECT = &H124&
Public Const WM_UNINITMENUPOPUP = &H125&
Public Const WM_MENUCOMMAND = &H126&
Public Const WM_CTLCOLORMSGBOX = &H132&
Public Const WM_CTLCOLOREDIT = &H133&
Public Const WM_CTLCOLORLISTBOX = &H134&
Public Const WM_CTLCOLORBTN = &H135&
Public Const WM_CTLCOLORDLG = &H136&
Public Const WM_CTLCOLORSCROLLBAR = &H137&
Public Const WM_CTLCOLORSTATIC = &H138&
Public Const WM_MOUSEFIRST = &H200&
Public Const WM_MOUSEMOVE = &H200&
Public Const WM_LBUTTONDOWN = &H201&
Public Const WM_LBUTTONUP = &H202&
Public Const WM_LBUTTONDBLCLK = &H203&
Public Const WM_RBUTTONDOWN = &H204&
Public Const WM_RBUTTONUP = &H205&
Public Const WM_RBUTTONDBLCLK = &H206&
Public Const WM_MBUTTONDOWN = &H207&
Public Const WM_MBUTTONUP = &H208&
Public Const WM_MBUTTONDBLCLK = &H209&
Public Const WM_MOUSEWHEEL = &H20A&
Public Const WM_MOUSELAST = &H20A&
Public Const WM_PARENTNOTIFY = &H210&
Public Const WM_ENTERMENULOOP = &H211&
Public Const WM_EXITMENULOOP = &H212&
Public Const WM_NEXTMENU = &H213&
Public Const WM_SIZING = &H214&
Public Const WM_CAPTURECHANGED = &H215&
Public Const WM_MOVING = &H216&
Public Const WM_POWERBROADCAST = &H218&
Public Const WM_DEVICECHANGE = &H219&
Public Const WM_MDICREATE = &H220&
Public Const WM_MDIDESTROY = &H221&
Public Const WM_MDIACTIVATE = &H222&
Public Const WM_MDIRESTORE = &H223&
Public Const WM_MDINEXT = &H224&
Public Const WM_MDIMAXIMIZE = &H225&
Public Const WM_MDITILE = &H226&
Public Const WM_MDICASCADE = &H227&
Public Const WM_MDIICONARRANGE = &H228&
Public Const WM_MDIGETACTIVE = &H229&
Public Const WM_MDISETMENU = &H230&
Public Const WM_ENTERSIZEMOVE = &H231&
Public Const WM_EXITSIZEMOVE = &H232&
Public Const WM_DROPFILES = &H233&
Public Const WM_MDIREFRESHMENU = &H234&
Public Const WM_IME_SETCONTEXT = &H281&
Public Const WM_IME_NOTIFY = &H282&
Public Const WM_IME_CONTROL = &H283&
Public Const WM_IME_COMPOSITIONFULL = &H284&
Public Const WM_IME_SELECT = &H285&
Public Const WM_IME_CHAR = &H286&
Public Const WM_IME_REQUEST = &H288&
Public Const WM_IME_KEYDOWN = &H290&
Public Const WM_IME_KEYUP = &H291&
Public Const WM_MOUSEHOVER = &H2A1&
Public Const WM_MOUSELEAVE = &H2A3&
Public Const WM_CUT = &H300&
Public Const WM_COPY = &H301&
Public Const WM_PASTE = &H302&
Public Const WM_CLEAR = &H303&
Public Const WM_UNDO = &H304&
Public Const WM_RENDERFORMAT = &H305&
Public Const WM_RENDERALLFORMATS = &H306
Public Const WM_DESTROYCLIPBOARD = &H307&
Public Const WM_DRAWCLIPBOARD = &H308&
Public Const WM_PAINTCLIPBOARD = &H309&
Public Const WM_VSCROLLCLIPBOARD = &H30A&
Public Const WM_SIZECLIPBOARD = &H30B&
Public Const WM_ASKCBFORMATNAME = &H30C&
Public Const WM_CHANGECBCHAIN = &H30D&
Public Const WM_HSCROLLCLIPBOARD = &H30E&
Public Const WM_QUERYNEWPALETTE = &H30F&
Public Const WM_PALETTEISCHANGING = &H310&
Public Const WM_PALETTECHANGED = &H311&
Public Const WM_HOTKEY = &H312&
Public Const WM_PRINT = &H317&
Public Const WM_PRINTCLIENT = &H318&
Public Const WM_HANDHELDFIRST = &H358&
Public Const WM_HANDHELDLAST = &H35F&
Public Const WM_AFXFIRST = &H360&
Public Const WM_AFXLAST = &H37F&
Public Const WM_PENWINFIRST = &H380&
Public Const WM_PENWINLAST = &H38F&
Public Const WM_APP = &H8000&
Public Const WM_USER = &H400&

Public Const WS_OVERLAPPED = &H0
Public Const WS_POPUP = &H80000000
Public Const WS_CHILD = &H40000000
Public Const WS_MINIMIZE = &H20000000
Public Const WS_VISIBLE = &H10000000
Public Const WS_DISABLED = &H8000000
Public Const WS_CLIPSIBLINGS = &H4000000
Public Const WS_CLIPCHILDREN = &H2000000
Public Const WS_MAXIMIZE = &H1000000
Public Const WS_CAPTION = &HC00000              '/* WS_BORDER | WS_DLGFRAME  */
Public Const WS_BORDER = &H800000
Public Const WS_DLGFRAME = &H400000
Public Const WS_VSCROLL = &H200000
Public Const WS_HSCROLL = &H100000
Public Const WS_SYSMENU = &H80000
Public Const WS_THICKFRAME = &H40000
Public Const WS_GROUP = &H20000
Public Const WS_TABSTOP = &H10000
Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_MAXIMIZEBOX = &H10000
Public Const WS_TILED = WS_OVERLAPPED
Public Const WS_ICONIC = WS_MINIMIZE
Public Const WS_SIZEBOX = WS_THICKFRAME

Public Const WS_EX_DLGMODALFRAME = &H1
Public Const WS_EX_NOPARENTNOTIFY = &H4
Public Const WS_EX_TOPMOST = &H8
Public Const WS_EX_ACCEPTFILES = &H10
Public Const WS_EX_TRANSPARENT = &H20
Public Const WS_EX_MDICHILD = &H40
Public Const WS_EX_TOOLWINDOW = &H80
Public Const WS_EX_WINDOWEDGE = &H100
Public Const WS_EX_CLIENTEDGE = &H200
Public Const WS_EX_CONTEXTHELP = &H400
Public Const WS_EX_RIGHT = &H1000
Public Const WS_EX_LEFT = &H0
Public Const WS_EX_RTLREADING = &H2000
Public Const WS_EX_LTRREADING = &H0
Public Const WS_EX_LEFTSCROLLBAR = &H4000
Public Const WS_EX_RIGHTSCROLLBAR = &H0
Public Const WS_EX_CONTROLPARENT = &H10000
Public Const WS_EX_STATICEDGE = &H20000
Public Const WS_EX_APPWINDOW = &H40000

Public Enum swpFlags
    SWP_NOSIZE = &H1&
    SWP_NOMOVE = &H2&
    SWP_NOZORDER = &H4&
    SWP_NOREDRAW = &H8&
    SWP_NOACTIVATE = &H10&
    SWP_FRAMECHANGED = &H20&
    SWP_SHOWWINDOW = &H40&
    SWP_HIDEWINDOW = &H80&
    SWP_NOCOPYBITS = &H100&
    SWP_NOOWNERZORDER = &H200&
    SWP_NOSENDCHANGING = &H400&
    SWP_DRAWFRAME = SWP_FRAMECHANGED
    SWP_NOREPOSITION = SWP_NOOWNERZORDER
    SWP_DEFERERASE = &H2000&
    SWP_ASYNCWINDOWPOS = &H4000&
End Enum

Public Enum SWPHwnd
    HWND_TOP = &H0&
    HWND_BOTTOM = &H1&
    HWND_TOPMOST = &HFFFFFFFF
    HWND_NOTOPMOST = &HFFFFFFFE
End Enum

Public Const GWL_EXSTYLE = (-20&)
Public Const GWL_HINSTANCE = (-6&)
Public Const GWL_HWNDPARENT = (-8&)
Public Const GWL_ID = (-12&)
Public Const GWL_STYLE = (-16&)
Public Const GWL_USERDATA = (-21&)
Public Const GWL_WNDPROC = (-4&)

Public Const GW_CHILD = 5&
Public Const GW_HWNDNEXT = 2&

Public Const MF_UNCHECKED = &H0&
Public Const MF_CHECKED = &H8&
Public Const MF_APPEND = &H100&
Public Const TPM_LEFTALIGN = &H0&
Public Const MF_DISABLED = &H2&
Public Const MF_GRAYED = &H1&
Public Const MF_SEPARATOR = &H800&
Public Const MF_STRING = &H0&
Public Const MF_BYPOSITION = &H400&
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' API Function Prototypes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Declare Function EnumChildWindows Lib "user32" _
                        (ByVal hwndParent As Long, _
                         ByVal lpEnumFunc As Long, _
                         ByRef lParam As Any) As Long

Private Declare Function EnumWindows Lib "user32" _
                        (ByVal lpEnumFunc As Long, _
                         ByRef lParam As Any) As Long


Private Declare Function FindWindow_API Lib "user32" Alias "FindWindowA" _
                        (ByVal lpClassName As String, _
                        ByVal lpWindowName As String) As Long



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION      :   WindowEnumeratorProc
' DISCUSSION    :
'   The common callback function passed to both EnumChildWindows and
'   EnumWindows.  A TWinCol is passed as the ByRef in the LPARAM and
'   this function simply adds the HWND to the collection.
' PARAMETERS    :
'   hWnd    - The standard enumerator parameter.
'   TWinCol - The TWindows collection jammed in as the LPARAM.
' RETURNS       :
'   Always returns 1 (C TRUE) to continue the enumeration.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright (c) 1997-2000 John Robbins -- All rights reserved.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function WindowEnumeratorProc(ByVal hWnd As Long, _
                                     ByRef TWinCol As TWindows) As Long
    TWinCol.Add hWnd
    WindowEnumeratorProc = 1
End Function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION      :   EnumChildrenWindowsIntoCollection
' DISCUSSION    :
'   Fills the specified TWindows collection with all child windows of
'   hWndParent.
' PARAMETERS    :
'   hWndParent - A valid HWND.
'   TWinCol    - An allocated TWindow collection.
' RETURNS       :
'   Whatever EnumChildWindows returns.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright (c) 1997-2000 John Robbins -- All rights reserved.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function EnumChildrenWindowsIntoCollection(hwndParent As Long, _
                                             TWinCol As TWindows) As Long
    EnumChildrenWindowsIntoCollection = _
            EnumChildWindows(hwndParent, _
                             AddressOf WindowEnumeratorProc, _
                             TWinCol)
End Function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FUNCTION      :   EnumTopWindowsIntoCollection
' DISCUSSION    :
'   Fills the TWindows collection with ALL the top level windows.
' PARAMETERS    :
'   TWinCol - The TWindows collection to fill.
' RETURNS       :
'   Whatever EnumWindows returns.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright (c) 1997-2000 John Robbins -- All rights reserved.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function EnumTopWindowsIntoCollection(TWinCol As TWindows) As Long
    EnumTopWindowsIntoCollection = _
            EnumWindows(AddressOf WindowEnumeratorProc, TWinCol)
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function FindTopWindow(ByVal szClass As String, _
                                ByVal szTitle As String, _
                                Optional ByVal bExactMatch As Boolean = True, _
                                Optional ByVal hwndParent As Long = 0) As TWindow

    Dim hWndC As Long
    Dim TTopWindows As New TWindows
    Dim i As Integer
    
    Set FindTopWindow = New TWindow
    
    If bExactMatch And hwndParent = 0 Then
        FindTopWindow.hWnd = FindWindow_API(szClass, szTitle)
    Else
        EnumTopWindowsIntoCollection TTopWindows
        For i = 1 To TTopWindows.Count
            If vbNullString = szTitle Then
                If (bExactMatch And TTopWindows(i).ClassName = szClass) Or _
                   (Not bExactMatch And InStr(1, TTopWindows(i).ClassName, szClass) <> 0) _
                Then
                    If TTopWindows(i).Parent.hWnd = hwndParent Or hwndParent = 0 Then
                        FindTopWindow.hWnd = TTopWindows(i).hWnd
                        Exit For
                    End If
                End If
            ElseIf vbNullString = szClass Then
                If (bExactMatch And TTopWindows(i).Caption = szTitle) Or _
                   (Not bExactMatch And InStr(1, TTopWindows(i).Caption, szTitle) <> 0) _
                Then
                    If TTopWindows(i).Parent.hWnd = hwndParent Or hwndParent = 0 Then
                        FindTopWindow.hWnd = TTopWindows(i).hWnd
                        Exit For
                    End If
                End If
            Else
                If (bExactMatch And TTopWindows(i).ClassName = szClass) Or _
                   (Not bExactMatch And InStr(1, TTopWindows(i).ClassName, szClass) <> 0) _
                Then
                    If (bExactMatch And TTopWindows(i).Caption = szTitle) Or _
                       (Not bExactMatch And InStr(1, TTopWindows(i).Caption, szTitle) <> 0) _
                    Then
                        If TTopWindows(i).Parent.hWnd = hwndParent Or hwndParent = 0 Then
                            FindTopWindow.hWnd = TTopWindows(i).hWnd
                            Exit For
                        End If
                    End If
                End If
            End If
        Next
    End If
    
    If FindTopWindow.hWnd = 0 Then
        Set FindTopWindow = Nothing
    End If

End Function


