VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "The object that lets you do more than you ever wanted to an HWND."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' "Debugging Applications" (Microsoft Press)
' Copyright (c) 1997-2000 John Robbins -- All rights reserved.
' Updated for June 2000 MSDN Magazine Bugslayer Column
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Some parts (R)2003 Sergiy Pavlov -- Do not remove this header
' baal_200@yahoo.com
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The object that lets you do more than you ever wanted to an HWND.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' API Function Prototypes
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Type WIN32RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function FindWindow_API Lib "user32" Alias "FindWindowA" _
    (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
    
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, _
    ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, _
    ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long

Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function GetWindowText Lib "user32" Alias _
        "GetWindowTextA" (ByVal hWnd As Long, _
                          ByVal lpString As String, _
                          ByVal cch As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias _
        "GetClassNameA" (ByVal hWnd As Long, _
                         ByVal lpClassName As String, _
                         ByVal nMaxCount As Long) As Long

Private Declare Function GetWindowRect Lib "user32" _
                        (ByVal hWnd As Long, _
                         ByRef lpRect As WIN32RECT) As Long

Private Declare Function IsWindow Lib "user32" _
                        (ByVal hWnd As Long) As Long

Private Declare Function IsWindowEnabled Lib "user32" _
                        (ByVal hWnd As Long) As Long


Private Declare Function IsWindowVisible Lib "user32" _
                        (ByVal hWnd As Long) As Long


Private Declare Function EnableWindow Lib "user32" _
                        (ByVal hWnd As Long, ByVal bEnable As Long) As Long


Private Declare Function GetWindowThreadProcessId Lib "user32" _
                        (ByVal hWnd As Long, _
                         ByRef lpdwProcessId As Long) As Long

Private Declare Function FindWindowEx Lib "user32" Alias _
        "FindWindowExA" (ByVal hwndParent As Long, _
                         ByVal hwndChildAfter As Long, _
                         ByVal lpszClass As String, _
                         ByVal lpszWindow As String) As Long

Private Declare Function SetForegroundWindow_API Lib "user32" Alias "SetForegroundWindow" _
                        (ByVal hWnd As Long) As Long

Private Declare Function SetFocus_API Lib "user32" Alias "SetFocus" _
                        (ByVal hWnd As Long) As Long

Private Declare Function PostMessageLong_API Lib "user32" _
    Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function PostMessageString_API Lib "user32" _
    Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Declare Function SendMessageLong_API Lib "user32" _
    Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function SendMessageString_API Lib "user32" _
    Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Declare Function SendMessageAny_API Lib "user32" _
    Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long

Private Declare Sub keybd_event_API Lib "user32" Alias "keybd_event" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)

Private Declare Function GetMenu_API Lib "user32" Alias "GetMenu" (ByVal hWnd As Long) As Long

Private Declare Function GetSubMenu_API Lib "user32" Alias "GetSubMenu" (ByVal hMenu As Long, ByVal nPos As Long) As Long

Private Declare Function AppendMenu_API Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lNewItem As String) As Long

Private Declare Function DestroyMenu_API Lib "user32" Alias "DestroyMenu" (ByVal hMenu As Long) As Long

Private Declare Function DrawMenuBar_API Lib "user32" Alias "DrawMenuBar" (ByVal hMenu As Long) As Long

Private Declare Function CheckMenuItem_API Lib "user32" Alias "CheckMenuItem" (ByVal hMenu As Long, ByVal uIDCheckItem As Long, ByVal uCheck As Long) As Long

Private Declare Function CreateWindowEx_API Lib "user32.dll" Alias "CreateWindowExA" _
                                                            (ByVal dwExStyle As Long, ByVal lpClassName As String, _
                                                             ByVal lpWindowName As String, ByVal dwStyle As Long, _
                                                             ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, _
                                                             ByVal nHeight As Long, ByVal hwndParent As Long, _
                                                             ByVal hMenu As Long, ByVal hInstance As Long, _
                                                             lpParam As Any) As Long
    
Private Declare Function DestroyWindow_API Lib "user32.dll" Alias "DestroyWindow" (ByVal hWnd As Long) As Long  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Class specific data.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The HWND for the class.
Private mvarhWnd As Long


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The Let/Get/Set property functions.  If you have a random HWND value,
' this allows you to set the internal data so you can access information
' about the HWND.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Let hWnd(ByVal vData As Long)
    mvarhWnd = vData
End Property

Public Property Get hWnd() As Long
    hWnd = mvarhWnd
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The properties and methods on this object are pretty self explanitory.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function CreateChildWindow(lpClassName As String, lpWindowName As String, _
                dwStyle As Long, dwExStyle As Long, _
                x As Long, y As Long, _
                nWidth As Long, nHeight As Long, _
                hMenu As Long) As Long
    CreateChildWindow = CreateWindowEx_API(dwExStyle, lpClassName, lpWindowName, dwStyle, x, y, nWidth, nHeight, Me.hWnd, hMenu, App.hInstance, ByVal CLng(0))
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function DestroyWindow() As Long
    If hWnd <> 0 Then
        DestroyWindow = DestroyWindow_API(hWnd)
        hWnd = 0
    End If
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Let Caption(sCaption As String)
    Dim lRet As Long
    lRet = SendMessageString(WM_SETTEXT, 0, sCaption)
End Property

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Caption() As String
    Dim str As String
    Dim lRet As Long

    str = String$(255, vbNullChar)

    lRet = SendMessageAny_API(mvarhWnd, WM_GETTEXT, 255, str)
    'lRet = GetWindowText(mvarhWnd, str, 255)

    If (lRet = 0) Then
        str = ""
    Else
        ' Clear out the extra characters off the end of the string.
        str = Left$(str, lRet)
    End If

    Caption = str
End Property

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Title() As String
    Title = Caption
End Property

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Let Title(sTitle As String)
    Caption = sTitle
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get ClassName() As String
    Dim str As String
    Dim lRet As Long

    str = String$(255, vbNullChar)

    lRet = GetClassName(mvarhWnd, str, 255)

    If (lRet = 0) Then
        str = ""
    Else
        ' Clear out the extra characters off the end of the string.
        str = Left$(str, lRet)
    End If

    ClassName = str

End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Top() As Long
    Dim wRect As WIN32RECT
    Dim lRet As Long

    lRet = GetWindowRect(mvarhWnd, wRect)
    If (0 <> lRet) Then
        Top = wRect.Top
    Else
        Top = 0
    End If

End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Height() As Long
    Dim wRect As WIN32RECT
    Dim Bottom As Long
    Dim lRet As Long

    lRet = GetWindowRect(mvarhWnd, wRect)
    If (0 <> lRet) Then
        Bottom = wRect.Bottom
    Else
        Bottom = 0
    End If
    
    Height = Bottom - Top
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Left() As Long
    Dim wRect As WIN32RECT
    Dim lRet As Long

    lRet = GetWindowRect(mvarhWnd, wRect)
    If (0 <> lRet) Then
        Left = wRect.Left
    Else
        Left = 0
    End If
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get width() As Long
    Dim wRect As WIN32RECT
    Dim Right As Long
    Dim lRet As Long

    lRet = GetWindowRect(mvarhWnd, wRect)
    If (0 <> lRet) Then
        Right = wRect.Right
    Else
        Right = 0
    End If
    
    width = Right - Left
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Valid() As Boolean
    Dim lRet As Long
    lRet = IsWindow(mvarhWnd)
    If (1 = lRet) Then
        Valid = True
    Else
        Valid = False
    End If
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Let Visible(bData As Boolean)
    Dim lRet As Long
    lRet = IsWindowVisible(mvarhWnd)
    If (1 = lRet) And bData = False Then
        Hide
    ElseIf (0 = lRet) And bData = True Then
        Show
    End If
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Visible() As Boolean
    Dim lRet As Long
    lRet = IsWindowVisible(mvarhWnd)
    If (1 = lRet) Then
        Visible = True
    Else
        Visible = False
    End If
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Enabled() As Boolean
    Dim lRet As Long
    lRet = IsWindowEnabled(mvarhWnd)
    If (1 = lRet) Then
        Enabled = True
    Else
        Enabled = False
    End If
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Let Enabled(bEnabled As Boolean)
    Dim lRet As Long
    lRet = EnableWindow(mvarhWnd, Abs(bEnabled))
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Parent() As TWindow
    Dim cRet As TWindow
    Dim hWndP As Long
    Set cRet = New TWindow

    hWndP = GetParent(mvarhWnd)

    If (0 = hWndP) Then
        cRet.hWnd = 0
    Else
        cRet.hWnd = hWndP
    End If

    Set Parent = cRet
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get ProcessId() As Long
    Dim lProcId As Long

    If (0 = GetWindowThreadProcessId(mvarhWnd, lProcId)) Then
        ProcessId = 0
    Else
        ProcessId = lProcId
    End If
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get ThreadId() As Long
    ThreadId = GetWindowThreadProcessId(mvarhWnd, 0)
End Property


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get id() As Long
    id = GetWindowLong(mvarhWnd, GWL_ID)
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Style() As Long
    Style = GetWindowLong(mvarhWnd, GWL_STYLE)
End Property

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Let Style(ByVal NewBits As Long)
    Dim lRet As Long
    lRet = SetWindowLong(mvarhWnd, GWL_STYLE, NewBits)
    Me.Redraw
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function SetForeground() As Long
    SetForeground = SetForegroundWindow_API(mvarhWnd)
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function SetFocus() As Long
    SetFocus = SetFocus_API(mvarhWnd)
End Function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function EnumChildren() As TWindows
    Dim TWinCol As TWindows
    Dim lRet As Long
    Set TWinCol = New TWindows

    lRet = EnumChildrenWindowsIntoCollection(mvarhWnd, TWinCol)

    If (1 <> lRet) Then
        Set TWinCol = Nothing
    End If

    Set EnumChildren = TWinCol
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function FindChildWindow(ByVal szClass As String, _
                                ByVal szTitle As String, _
                                Optional ByVal bExactMatch As Boolean = True) As TWindow

    Dim hWndC As Long
    Set FindChildWindow = New TWindow
    
    If bExactMatch Then
        FindChildWindow.hWnd = FindWindowEx(mvarhWnd, 0, szClass, szTitle)
    Else
        FindChildWindow.hWnd = GetWindow(mvarhWnd, GW_CHILD)
        Do While FindChildWindow.hWnd <> 0
            If vbNullString = szTitle Then
                If InStr(1, FindChildWindow.ClassName, szClass) <> 0 Then
                    Exit Do
                End If
            Else
                If InStr(1, FindChildWindow.Caption, szTitle) <> 0 Then
                    Exit Do
                End If
            End If
            FindChildWindow.hWnd = GetWindow(FindChildWindow.hWnd, GW_HWNDNEXT)
        Loop
    End If

    If FindChildWindow.hWnd = 0 Then
        Set FindChildWindow = Nothing
    End If
    
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function GetMenu() As TWindow
    'Me is a Form (Dialog) window
    Set GetMenu = New TWindow
    
    If mvarhWnd <> 0 Then
        GetMenu.hWnd = GetMenu_API(mvarhWnd)
    End If
    
    If GetMenu.hWnd = 0 Then
        Set GetMenu = Nothing
    End If
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function GetSubMenu(nPos As Long) As TWindow
    'Me is a menu Item
    Set GetSubMenu = New TWindow
    
    If mvarhWnd <> 0 Then
        GetSubMenu.hWnd = GetSubMenu_API(mvarhWnd, nPos)
    End If
    
    If GetSubMenu.hWnd = 0 Then
        Set GetSubMenu = Nothing
    End If
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function AppendMenu(sCaption As String, Optional wFlags As Long = MF_STRING) As TWindow
    'Me is a menu Item
    Set AppendMenu = New TWindow
    
    If mvarhWnd <> 0 Then
        AppendMenu.hWnd = AppendMenu_API(mvarhWnd, wFlags, ByVal 0&, sCaption)
    End If
    
    If AppendMenu.hWnd = 0 Then
        Set AppendMenu = Nothing
    End If
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DestroyMenu()
    'Me is a menu Item
    
    If mvarhWnd <> 0 Then
        If DestroyMenu_API(mvarhWnd) <> 0 Then
            'Successfully Destroyed
            mvarhWnd = 0
        End If
    End If
    
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub DrawMenuBar()
   ' Redraw window's Menu.
   Dim lRet As Long
   lRet = DrawMenuBar_API(mvarhWnd)
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub CheckMenuItem(nPosition As Long, bIsChecked As Boolean)
   ' Redraw window's Menu.
   Dim lRet As Long
   lRet = CheckMenuItem_API(mvarhWnd, nPosition, MF_BYPOSITION Or IIf(bIsChecked, MF_CHECKED, MF_UNCHECKED))
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub Redraw()
   ' Redraw window.
   Const swpFlags As Long = _
      SWP_FRAMECHANGED Or SWP_NOMOVE Or _
      SWP_NOZORDER Or SWP_NOSIZE
   Call SetWindowPos(mvarhWnd, 0, 0, 0, 0, 0, swpFlags)
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Hide()
   If mvarhWnd <> 0 Then
        Call SetWindowPos(mvarhWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_HIDEWINDOW Or SWP_NOMOVE Or SWP_NOSIZE)
   End If
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Show()
   If mvarhWnd <> 0 Then
        Call SetWindowPos(mvarhWnd, HWND_TOP, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE)
   End If
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub SetTopMost(bIsTopMost As Boolean)
   Call SetWindowPos(mvarhWnd, IIf(bIsTopMost, HWND_TOPMOST, HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub SendLMouseClick(x As Long, y As Long)
    Dim lngResult As Long
    Dim lnglParam As Long
              
    lnglParam = (y * &H10000) + x
       
    lngResult = SendMessageLong_API(mvarhWnd, WM_LBUTTONDOWN, 0&, lnglParam)
    lngResult = SendMessageLong_API(mvarhWnd, WM_LBUTTONUP, 0&, lnglParam)
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub SendRMouseClick(x As Long, y As Long)
    Dim lngResult As Long
    Dim lnglParam As Long
              
    lnglParam = (y * &H10000) + x
       
    lngResult = SendMessageLong_API(mvarhWnd, WM_RBUTTONDOWN, 0&, lnglParam)
    lngResult = SendMessageLong_API(mvarhWnd, WM_RBUTTONUP, 0&, lnglParam)
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function PostMessageString(ByVal wMsg As Long, Optional ByVal wParam As Long = 0, Optional ByVal lParam As String = vbNullString) As Long
    If IsWindow(mvarhWnd) Then _
        PostMessageString = PostMessageString_API(hWnd, mvarhWnd, Abs(wParam), lParam)
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function PostMessageLong(ByVal wMsg As Long, Optional ByVal wParam As Long = 0, Optional ByVal lParam As Long = 0) As Long
    If IsWindow(mvarhWnd) Then _
        PostMessageLong = PostMessageLong_API(mvarhWnd, wMsg, Abs(wParam), Abs(lParam))
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function SendMessageString(ByVal wMsg As Long, Optional ByVal wParam As Long = 0, Optional ByVal lParam As String = vbNullString) As Long
    If IsWindow(mvarhWnd) Then _
        SendMessageString = SendMessageString_API(mvarhWnd, wMsg, Abs(wParam), lParam)
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Function SendMessageLong(ByVal wMsg As Long, Optional ByVal wParam As Long = 0, Optional ByVal lParam As Long = 0) As Long
    If IsWindow(mvarhWnd) Then _
        SendMessageLong = SendMessageLong_API(mvarhWnd, wMsg, Abs(wParam), Abs(lParam))
End Function

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub SendKey(ByVal vKey As Byte)
    If IsWindow(mvarhWnd) Then
        SetFocus_API (mvarhWnd)
        keybd_event_API vKey, 0, 0, 0
        keybd_event_API vKey, 0, KEYEVENTF_KEYUP, 0
    End If
End Sub

'(R)2003 Sergiy Pavlov''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub SendCtrlKey(ByVal vKey As Byte)
    If IsWindow(mvarhWnd) Then
        SetFocus_API (mvarhWnd)
        keybd_event_API VK_CONTROL, 0, 0, 0
        keybd_event_API vKey, 0, 0, 0
        keybd_event_API vKey, 0, KEYEVENTF_KEYUP, 0
        keybd_event_API VK_CONTROL, 0, KEYEVENTF_KEYUP, 0
    End If
End Sub

'(R)2003 Sergiy Pavlov'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub SendAltKey(ByVal vKey As Byte)
    If IsWindow(mvarhWnd) Then
        SetFocus_API (mvarhWnd)
        keybd_event_API TWindowSupport.VK_MENU, 0, 0, 0
        keybd_event_API vKey, 0, 0, 0
        keybd_event_API vKey, 0, KEYEVENTF_KEYUP, 0
        keybd_event_API VK_MENU, 0, KEYEVENTF_KEYUP, 0
    End If
End Sub

'(R)2003 Sergiy Pavlov'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub Class_Initialize()
    mvarhWnd = 0
End Sub
